Population annealing, one of the currently state-of-the-art algorithms for solving spin-glass systems, sometimes finds hard disorder instances for which its equilibration quality at each temperature step is severely damaged. In such cases, therefore, one cannot be sure about having reached the true ground state without vastly increasing the computational resources. In this work, we seek to overcome this problem by proposing a quantum-inspired modification of population annealing. Here we focus on the three-dimensional random plaquette gauge model, whose ground-state energy problem seems to be much harder to solve than that of the standard spin-glass Edwards-Anderson model. In analogy to the toric code, by allowing single bond flips we let the system explore nonphysical states, effectively expanding the configurational space by introducing topological defects that are then annealed through an additional field parameter. The dynamics of these defects allow for the effective realization of nonlocal cluster moves, potentially easing the equilibration process. We study the performance of this method in three-dimensional random plaquette gauge model lattices of various sizes, and we compare it against population annealing. With that we conclude that the newly introduced nonlocal moves are able to improve the equilibration of the lattices, in some cases being superior to a normal population annealing algorithm with a computational resource investment that is 16 times higher.
Population annealing, one of the currently state-of-the-art algorithms for solving spin-glass systems, sometimes finds hard disorder instances for which its equilibration quality at each temperature step is severely damaged. In such cases, therefore, one cannot be sure about having reached the true ground state without vastly increasing the computational resources. In this work, we seek to overcome this problem by proposing a quantum-inspired modification of population annealing. Here we focus on the three-dimensional random plaquette gauge model, whose ground-state energy problem seems to be much harder to solve than that of the standard spin-glass Edwards-Anderson model. In analogy to the toric code, by allowing single bond flips we let the system explore nonphysical states, effectively expanding the configurational space by introducing topological defects that are then annealed through an additional field parameter. The dynamics of these defects allow for the effective realization of nonlocal cluster moves, potentially easing the equilibration process. We study the performance of this method in three-dimensional random plaquette gauge model lattices of various sizes, and we compare it against population annealing. With that we conclude that the newly introduced nonlocal moves are able to improve the equilibration of the lattices, in some cases being superior to a normal population annealing algorithm with a computational resource investment that is 16 times higher.
Spin glasses are disordered magnets with random interactions that are, generally, in conflict with each other. Finding the ground states of spin glasses is not only essential for understanding the nature of disordered magnets and many other physical systems, but also useful to solve a broad array of hard combinatorial optimization problems across multiple disciplines. Despite decades-long efforts, an algorithm with both high accuracy and high efficiency is still lacking. Here we introduce DIRAC - a deep reinforcement learning framework, which can be trained purely on small-scale spin glass instances and then applied to arbitrarily large ones. DIRAC displays better scalability than other methods and can be leveraged to enhance any thermal annealing method. Extensive calculations on 2D, 3D and 4D Edwards-Anderson spin glass instances demonstrate the superior performance of DIRAC over existing methods. The presented framework will help us better understand the nature of the low-temperature spin-glass phase, which is a fundamental challenge in statistical physics. Moreover, the gauge transformation technique adopted in DIRAC builds a deep connection between physics and artificial intelligence. In particular, this opens up a promising avenue for reinforcement learning models to explore in the enormous configuration space, which would be extremely helpful to solve many other hard combinatorial optimization problems.
Spin glasses are disordered magnets with random interactions that are, generally, in conflict with each other. Finding the ground states of spin glasses is not only essential for the understanding of the nature of disordered magnetic and other physical systems, but also useful to solve a broad array of hard combinatorial optimization problems across multiple disciplines. Despite decades-long efforts, an algorithm with both high accuracy and high efficiency is still lacking. Here we introduce DIRAC - a deep reinforcement learning framework, which can be trained purely on small-scale spin glass instances and then applied to arbitrarily large ones. DIRAC displays better scalability than other methods and can be leveraged to enhance any thermal annealing method. Extensive calculations on 2D, 3D and 4D Edwards-Anderson spin glass instances demonstrate the superior performance of DIRAC over existing methods. As many hard combinatorial optimization problems have Ising spin glass formulations, our results suggest a promising tool in solving these hard problems. Moreover, the presented algorithm will help us better understand the nature of the low-temperature spin-glass phase, which is a fundamental challenge in statistical physics.
Spin glasses are experiencing a revival due to applications in quantum information\ntheory. In particular, they are the archetypal native benchmark problem for quantum annealing\nmachines. Furthermore, they find applications in fields as diverse as satisfiability,\nneural networks, and general combinatorial optimization problems. As such, developing\nand improving algorithms and methods to study these computationally complex systems\nis of paramount importance to many disciplines. This body of work attempts to attack\nthe problem of solving combinatorial optimization problems by simulating spin glasses\nfrom three sides: classical algorithm development, suggestions for quantum annealing\ndevice design, and improving measurements in realistic physical systems with inherent\nnoise. I begin with the introduction of a cluster algorithm based on Houdayer’s cluster algorithm\nfor two-dimensional Ising spin-glasses that is applicable to any space dimension\nand speeds up thermalization by several orders of magnitude at low temperatures where\nprevious algorithms have difficulty. I show improvement for the D-Wave chimera topology\nand the three-dimensional cubic lattice that increases with the size of the problem.\nOne consequence of adding cluster moves is that for problems with degenerate solutions,\nground-state sampling is improved. I demonstrate an ergodic algorithm to sample ground\nstates through the use of simple Monte Carlo with parallel tempering and cluster moves.\nIn addition, I present a non-ergodic algorithm to generate new solutions from a bank of\nknown solutions. I compare these results against results from quantum annealing utilizing\nthe D-Wave Inc. quantum annealing device. Finally, I present an algorithm for improving\nthe recovery of ground-state solutions from problems with noise by using thermal fluctuations\nto infer the correct solution at the Nishimori temperature. While this method has been\ndemonstrated analytically and numerically for trivial ferromagnetic and Gaussian distributions, a useful metric for more complex Gaussian distributions with added Gaussian noise\nis unavailable. We show improved recovery of numerical solutions on the chimera graph\nwith a ferromagnetic distribution and added Gaussian noise. Next, I direct my focus to the\ndesign of future generations of quantum annealers. The first design is the two-dimensional\nsquare-lattice bimodal spin glass with next-nearest ferrromagnetic interactions proposed\nby Lemke and Campbell claimed to exhibit a finite-temperature spin-glass state for a particular\nrelative strength of the next-nearest to nearest neighbor interactions. Our results\nfrom finite-temperature simulations show the system is in a paramagnetic state in the thermodynamic\nlimit, thus not useful for quantum annealing device designs that would benefit\nfrom a spin-glass phase transition. The second design is the diluted next-nearest neighbor\nIsing spin-glass with Gaussian interactions in an attempt to improve the estimation\nof critical parameter with smaller system sizes by implementing averaging of observables\nover different graph dilutions. To date, this model has shown no improvement. Finally,\nI make suggestions for the choice of distributions of interactions that are robust to noise\nand present a method for using previously unaccessible continuous distributions. I begin\nwith showing the best-case performance of quantum annealing devices. I show results for\nthe resilience, the probability that the ground-state solution has changed due to inherent\nanalog noise in the device, and present strategies for developing robust instance classes.\nThe analog noise is also detrimental to interactions chosen from continuous distributions.\nUsing Gaussian quadratures, I present a method for discretizing continuous distributions\nto reduce noise effects. Simulations on the D-Wave show that the average residual of\nthe ground-state energy with the true ground-state energy is calculated and shown to be\nsmaller in the case of the discrete distribution.
We analyze scaling behaviors of simulated annealing carried out on various classical systems with topological order, obtained as appropriate limits of the toric code in two and three dimensions. We first consider the three-dimensional Z2 (Ising) lattice gauge model, which exhibits a continuous topological phase transition at finite temperature. We show that a generalized Kibble-Zurek scaling ansatz applies to this transition, in spite of the absence of a local order parameter. We find perimeter-law scaling of the magnitude of a nonlocal order parameter (defined using Wilson loops) and a dynamic exponent $z=2.70\ifmmode\pm\else\textpm\fi{}0.03$, the latter in good agreement with previous results for the equilibrium dynamics (autocorrelations). We then study systems where (topological) order forms only at zero temperature---the Ising chain, the two-dimensional Z2 gauge model, and a three-dimensional star model (another variant of the Z2 gauge model). In these systems the correlation length diverges exponentially, in a way that is nonsmooth as a finite-size system approaches the zero temperature state. We show that the Kibble-Zurek theory does not apply in any of these systems. Instead, the dynamics can be understood in terms of diffusion and annihilation of topological defects, which we use to formulate a scaling theory in good agreement with our simulation results. We also discuss the effect of open boundaries where defect annihilation competes with a faster process of evaporation at the surface.
Population annealing Monte Carlo is an efficient sequential algorithm for simulating k-local Boolean Hamiltonians. Because of its structure, the algorithm is inherently parallel and therefore well suited for large-scale simulations of computationally hard problems. Here we present various ways of optimizing population annealing Monte Carlo using 2-local spin-glass Hamiltonians as a case study. We demonstrate how the algorithm can be optimized from an implementation, algorithmic accelerator, as well as scalable parallelization points of view. This makes population annealing Monte Carlo perfectly suited to study other frustrated problems such as pyrochlore lattices, constraint-satisfaction problems, as well as higher-order Hamiltonians commonly found in, e.g., topological color codes.
Although quantum annealing is usually considered as a method for locating the ground states of difficult spin-glass and optimization problems, its use in approximate optimization -- finding low- but not zero-energy states in a reasonably short amount of time -- is no less important. Here we investigate the behavior of quantum annealing at approximate optimization in the canonical mean-field spin-glass models, the spherical p-spin models, and find that it performs surprisingly well. Whereas it had long been assumed that infinite-range spin glasses have a unique ``threshold'' energy at which all quench and annealing dynamics become trapped until exponential timescales, recent work has shown that two-stage quenches can in fact reach states below the naive threshold in more generic situations. We demonstrate that quantum annealing is also capable of exploiting this effect to locate sub-threshold states in O(1) time. Not only can it attain energies as far below the threshold as classical annealing algorithms, but it can do so significantly faster: for an annealing schedule taking time τ, the residual energy under quantum annealing decays as τ−α with an exponent up to twice as large as that of simulated annealing in the cases considered. Importantly, by deriving and numerically solving closed integro-differential equations that hold in the thermodynamic limit, our results are free from finite-size effects and hold for annealing times that are unambiguously independent of system size.